<template>
    <v-card>
        <v-card-title class="headline">{{ title }}</v-card-title>
        <v-form ref="addService">
            <v-card-text>
                <v-container>
                    <v-text-field required v-model="currentService.name" :rules="rules.name" :label="$t('service-name')">
                    </v-text-field>

                    <v-text-field required v-model="currentService.address" :rules="rules.ip" :label="$t('service-address')">
                    </v-text-field>

                    <v-text-field required v-model="currentService.port" :rules="rules.port" :label="$t('service-port')">
                    </v-text-field>

                    <v-text-field required v-model="currentService.refreshPeriod" :rules="rules.refreshPeriod" :label="$t('service-refreshPeriod')">
                    </v-text-field>

                    <v-switch v-model="currentService.monitored" :label="$t('service-monitored')">
                    </v-switch>
                </v-container>
            </v-card-text>
            <v-card-actions>
                <v-btn color="normal" class="ma-2" @click="cancel">{{ cancelButton }}</v-btn>
                <v-spacer></v-spacer>
                <v-btn color="primary" class="ma-2" @click="submit(isUpdate)">{{ addOrUpdate }}</v-btn>
            </v-card-actions>
        </v-form>
    </v-card>
</template>

<script>
    import APIService from "@/api/ServicesAPI.js";

    const apiService = new APIService();

    export default {
        name: "CreateService",
        props: {
            title: {
                type: String,
                default: "",
            },
            cancelButton: {
                type: String,
                default: "",
            },
            addOrUpdate: {
                type: String,
                default: "",
            },
            currentService: {
                type: Object,
                default: () => { 
                    return {
                        name: "",
                        ip: "",
                        port: "",
                        monitored: true,
                        refreshPeriod: "",
                    };
                },
            },
            isUpdate: {
                type: Boolean,
                default: false,
            },
        },
        data () {
            return {
                /*newService: {
                    name: "",
                    ip: "",
                    port: "",
                    monitored: true,
                    refreshPeriod: "",
                },*/
                rules: {
                    name: [
                        v => !!v || "Un nom de service est requis !",
                    ],
                    ip: [
                        v => !!v || "L'adresse IP est requise !",
                        v => /[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/.test(v) || "Veuillez indiquer une adresse IP valide",
                    ],
                    port: [
                        v => !!v || "un numéro de port est requis !",
                        v => !isNaN(v) || "Veuillez indiquer un numéro de port valide",
                        v => ((0 <= v) && (v <= 65535)) || "Veuillez indiquer un numéro de port valide",
                    ],
                    refreshPeriod: [
                        v => !!v || "Une période de rafraîchissement du service doit être définie !",
                        v => !isNaN(v) || "Veuillez indiquer une période de rafraîchissement valide",
                    ],
                },
            };
        },
        methods: {
            async submit(isUpdate) {
                try {
                    if(this.$refs.addService.validate()) {
                        console.log("Submit");
                        if(isUpdate === true) {
                            let data = await apiService.updateService({
                                _id: this.currentService._id,
                                name: this.currentService.name,
                                address: this.currentService.address,
                                port: this.currentService.port,
                                monitored: this.currentService.monitored,
                                refreshPeriod: this.currentService.refreshPeriod,
                            });
                            console.log(data);
                            this.$emit("exit");
                            this.$noty.success(this.$t("service-updated"));
                        }
                        else {
                            let data = await apiService.createService({
                                name: this.currentService.name,
                                address: this.currentService.address,
                                port: this.currentService.port,
                                monitored: this.currentService.monitored,
                                refreshPeriod: this.currentService.refreshPeriod,
                            });
                            console.log(data);
                            this.$refs.addService.reset();
                            this.$emit("exit", "createService");
                            this.$emit("refresh");
                            this.$noty.success(this.$t("service-created"));
                        }
                    }
                } catch (err) {
                    console.error(`Error has occured : ${err}`);
                }
            },
            cancel () {
                this.$refs.addService.reset();
                this.$emit("exit", "createService");
            },
        },
    };
</script>

<i18n>
{
    "en": {
        "service-created": "Service created !",
        "service-updated": "Service updated !",
        "service-name": "Name of the service",
        "service-address": "IP Adress of the service",
        "service-port": "Port",
        "service-refreshPeriod": "Refresh period (in seconds)",
        "service-monitored": "Monitor the service ?"
    },
    "fr": {
        "service-created": "Service ajouté !",
        "service-updated": "Service modifié !",
        "service-name": "Nom du service",
        "service-address": "Adresse IP du service",
        "service-port": "Port",
        "service-refreshPeriod": "Période de rafraîchissement (en secondes)",
        "service-monitored": "Surveiller le service ?"
    }
}
</i18n>